#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Oct 17 13:06:39 2021

@author: eriboulet
"""

# Fentes d'Young : interférences et diffraction

# Longueur d'onde : l
# Distance entre les fentes : a
# Largeur d'une fente : b
# Distance fentes/écran : D
# Position du point M sur l'écran (origine dans le plan médian des fentes) : x
# f(x) : intensité relative (maximum = 1)
# g(x) : enveloppe

l = 632.8 # en nm (laser Hélium/Néon rouge)
a = 1 # en mm
b = 0.1 # en mm
D = 2 # en m

interfrange = round(l*D/a*1e-4,2) # interfrange (en cm)
print('interfrange =',interfrange,'cm')
pseudoperiode = round(l*D/b*1e-4,2) # périodicité du motif (en cm)
print('pseudopériode =',pseudoperiode,'cm')

from numpy import *
import matplotlib.pyplot as plt

x=linspace(-3,3,500)

def f(x):
    return 1/2*(1+cos(2*pi*a*x/l/D*1e4))*(sin(pi*b*x/l/D*1e4)/(pi*b*x/l/D*1e4))**2
def g(x):
    return (sin(pi*b*x/l/D*1e4)/(pi*b*x/l/D*1e4))**2
plt.xlabel('x(cm)')
plt.plot(x,f(x))
plt.plot(x,g(x))
plt.show()